#ifndef BOOL_TYPE
#define BOOL_TYPE
typedef short bool;
#endif

typedef struct {
	GsDOBJ2	handler;
	u_long *modelAddress;
	int whichModel;
	VECTOR position;		// position
	SVECTOR rotate;			// angle
	GsCOORDINATE2 coord;	 // coordinate system
} TMD_ObjectHandler;

#define MAX_BLOCKS 24

typedef struct {
	GsCOORDUNIT root;
	GsUNIT primBlocks[MAX_BLOCKS];
	int numPrimBlocks;	// Number of Primitive Blocks
	GsCOORDUNIT *coordinates;
	u_long *modelAddress;
	SVECTOR position;		// position
	SVECTOR translations[MAX_BLOCKS];
	SVECTOR rotate;			// angle
	int numAnims;
	GsSEQ *sequence;
} HMD_ObjectHandler;

typedef struct {
	u_short FileID;  // Should be 0xAAAA
	u_char Version;
	u_char NumJoints;
	u_short NumFrames;
	u_short FrameRate;
	SVECTOR *Translation;
	SVECTOR *Rotation;
} AnimFileHeader;

typedef enum { STOPPED = 0,
				 STOP_TO_WALK1, WALK1_TO_STOP, WALK2_TO_STOP, WALK1_TO_WALK2, WALK2_TO_WALK1,
				 STOP_TO_BACKWALK1, BACKWALK1_TO_STOP, BACKWALK2_TO_STOP, BACKWALK1_TO_BACKWALK2, BACKWALK2_TO_BACKWALK1,
				 STOMP,
				 BORED
			 } WALKSTATE;

typedef enum { NORMAL_CAMERA, REFLECTION_CAMERA } CAMERA_MODE;

typedef enum { OFF, VOLUME_UP, RUMBLING, VOLUME_DOWN } VOLCANO_STATUS;

void initialiseTMD(u_long *tmd, char objNum, TMD_ObjectHandler *oh);
void initialiseHMD(u_long *tmd, HMD_ObjectHandler *oh);
void initialise3D(void);
void DrawTMDModel(TMD_ObjectHandler *p, GsOT *ot, int OT_Len);
void createWorldToScreenMatrix(GsRVIEW2 *v, CAMERA_MODE mode);

void initAnimateHMD(char *animation, bool adjustBackOff);
void AnimateHMD(HMD_ObjectHandler *hmd, char *animation, bool advance);
void processVolcano(void);
void fadeInShadow(void);
void WalkTriceratops(bool walkFlag);
void ProcessTriceratopsReflectionHMD(bool drawTTopsFlag);
void ProcessTriceratopsHMD(void);
void ProcessEnvironmentHMDModels(void);
void ProcessHMDModel(HMD_ObjectHandler *hmd, GsOT *ot);

#ifdef SOURCE_3D_C
#define _3D_EXTERN_ON
#else
#define _3D_EXTERN_ON extern
#endif

_3D_EXTERN_ON SVECTOR CameraRotate, ReflectionCamera;

_3D_EXTERN_ON GsRVIEW2 TopView,ReflectionView;
_3D_EXTERN_ON WALKSTATE currentState, desiredState;
_3D_EXTERN_ON int tailAnimFrame;
_3D_EXTERN_ON int headMoveLeftRight, headMoveUpDown;
_3D_EXTERN_ON int mouthMoveFrame,roarNumber;
_3D_EXTERN_ON int VolcanoDualShockIntensity;
_3D_EXTERN_ON int triceratopsAngle;		// The ttops moves around a circle, this
											// is the angle related to that position.
											// It is used to determine whether
											// we should draw the ttops in the reflection.
#define PROJECTION_DISTANCE 500
