#define DEVKIT
// Comman global variables for all modules.

//----------- Useful macros ---------------------

#define BIT(x) (1 << (x))

//#define setVector(v,x,y,z) (v)->vx = (x), (v)->vy = (y), (v)->vz = (z)
#define setNormal(n,x,y,z) (n)->nx = (x), (n)->ny = (y), (n)->nz = (z)
#define setColor(c,_r,_g,_b) (c)->r = (_r), (c)->g = (_g), (c)->b = (_b)
//#define copyVector(v0,v1) (v1)->vx = (v0)->vx, (v1)->vy = (v0)->vy, (v1)->vz = (v0)->vz
#define addVector(v0,v1) (v0)->vx += (v1)->vx, (v0)->vy += (v1)->vy, (v0)->vz += (v1)->vz
#define subVector(v0,v1) (v0)->vx -= (v1)->vx, (v0)->vy -= (v1)->vy, (v0)->vz -= (v1)->vz
//#define applyVector(v,x,y,z,op) (v)->vx op x, (v)->vy op y, (v)->vz op z
#define dotProduct(v1,v2) ((v1)->vx * (v2)->vx / 4096 + (v1)->vy * (v2)->vy / 4096 + (v1)->vz * (v2)->vz / 4096)

#define KeepWithinRange(n, min, max) \
	(n)=(((n)<(min))?(min):(((n)>(max))?(max):(n)))

#define min(x,y) (((x)<(y))?(x):(y))
#define max(x,y) (((x)>(y))?(x):(y))


#ifndef BOOL_TYPE
#define BOOL_TYPE
typedef short bool;
#endif


#ifdef DEBUG
#define debugStr(s) printf(s)
#else
#define debugStr(s)
#endif

//----------- Global constants ------------------

#define CLOSEST_CAMERA_DISTANCE 100
#define FURTHEST_CAMERA_DISTANCE 6020

#define LOWEST_CAMERA_Y 300
#define CAMERA_LEVEL_Y 150
#define HIGHEST_CAMERA_Y 2300


#define TRUE 1
#define FALSE 0

#ifndef NULL
#define NULL 0
#endif


#ifdef _MAIN_
#define MAIN_EXTERN_ON
#else
#define MAIN_EXTERN_ON extern
#endif
MAIN_EXTERN_ON int BoredTimer, StompStatus;
MAIN_EXTERN_ON bool g_Quit;
MAIN_EXTERN_ON short int backGroundR,backGroundG,backGroundB;
MAIN_EXTERN_ON HMD_ObjectHandler triceratopsHMD,
								 innerTreeHMD,
								 environmentHMD,
								 environmentNPHMD,
								 treeHMD;
MAIN_EXTERN_ON TMD_ObjectHandler birdTMD;
MAIN_EXTERN_ON int CameraShudder_UD, CameraShudder_LR;

MAIN_EXTERN_ON bool introModeOn;
MAIN_EXTERN_ON int reflectionMode;

MAIN_EXTERN_ON int CameraDistance;
MAIN_EXTERN_ON int CameraAngle;
MAIN_EXTERN_ON int CameraLookUpDownAngle;
MAIN_EXTERN_ON int CameraHeight;


#undef MAIN_EXTERN_ON

void init(void);
void exitProgram(void);
void CreateOTforGround(void);
void CreateOTforMainScene(void);
void CreateOTforReflection(void);

